package at.jku.students;

import at.jku.ssw.Set;
import at.jku.ssw.Iterator;

public class SortedSet extends Set {
  
  private int elements;
  
  public SortedSet() {
    // keep visible
  }
  
  private SortedSet(int elements) {
    this.elements = elements;
  }
  
  public void add(char value) {
    if (value < 'a' || value > 'z') {
      throw new IllegalArgumentException("invalid character, must be between 'a' and 'z'");
    }
    elements |= toSet(value);
  }
  
  private int toSet(char value) {
    return 1 << (value - 'a');
  }
  
  public Iterator iterator() {
    return new SortedSetIterator(new SortedSet(elements));
  }
  
  public boolean get(char value) {
    if (value < 'a' || value > 'z') {
      throw new IllegalArgumentException("invalid character, must be between 'a' and 'z'");
    }
    return 0 != (elements & toSet(value));
  }
  
  public int size() {
    Iterator it = iterator();
    int size = 0;
    while (it.hasNext()) {
      it.next();
      size++;
    }
    return size;
  }
  
  public boolean remove(char value) {
    if (value < 'a' || value > 'z') {
      throw new IllegalArgumentException();
    }
    if (get(value)) {
      elements &= ~ toSet(value);
      return true;
    } else {
      return false;
    }
  }
  
  public Set intersect(Set other) {
    // TO DO
    return null;
  }
  
  public Set union(Set other) {
    // TO DO
    return null;
  }
  
  public Set diff(Set other) {
    // TO DO
    return null;
  }
  
  public Set subset(char from, char to) {
    // TO DO
    return null;
  }
}